#include <bits/stdc++.h>

using namespace std;

#define int long long

vector <int> fib;
vector <int> arr_off;
vector <int> arr_ei;

void fill_ei()
{
    arr_ei.push_back(0);
    for (int i = 1; i < 30; i++) {
        arr_ei.push_back(i);
    }
}

void fill_off()
{
    arr_off.push_back(0);
    for (int i = 1; i < 15; i++) {
        arr_off.push_back(arr_off[i - 1] + i + 1);
    }
}

void fill_fib()
{
    int f1 = 1, f2 = 1;
    fib.push_back(1);
    fib.push_back(1);
    while (f2 < 1e9) {
        fib.push_back(f2);
        int temp = f1;
        f1 = f2;
        f2 = temp + f1;
    }
    reverse(fib.begin(), fib.end());
}

void solve()
{
    int n;
    cin >> n;
    int tt = n;
    int off = 0, ei = 0;
    for (auto x : fib) {
        while (tt % x == 0 && x != 1) {
            if (x == 144) off++;
            if (x == 8) ei++;
            tt = tt / x;
        }
    }
    int res = 0;
    if (tt == 1) {
        res = 1 + arr_off[off] + arr_ei[ei];
    }
    cout << res << '\n';
}

signed main()
{
    fill_fib();
    fill_off();
    fill_ei();
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
    return 0;
}
