#include <bits/stdc++.h>

using namespace std;

#define int long long

vector <int> fib;
vector <int> arr_off;
vector <int> arr_ei;
vector <vector <int>> arr;

void fill_ei()
{
    arr_ei.push_back(1);
    for (int i = 1; i < 30; i++) {
        arr_ei.push_back(i + 1);
    }
}

void fill_off()
{
    arr_off.push_back(1);
    for (int i = 1; i < 15; i++) {
        arr_off.push_back(arr_off[i - 1] + i + 2);
    }
}

void fill_fib()
{
    int f1 = 1, f2 = 1;
    fib.push_back(1);
    while (f2 < 1e18) {
        fib.push_back(f2);
        int temp = f1;
        f1 = f2;
        f2 = temp + f1;
    }
    reverse(fib.begin(), fib.end());
}

void fill()
{
    for (int i = 0; i < 30; i++) {
        vector <int> temp;
        temp.push_back(arr_ei[i] * arr_off[0]);
        for (int j = 1; j < 15; j++) {
            if (i == 0) temp.push_back(arr_ei[0] * arr_off[j]);
            else {
                temp.push_back(arr_ei[i] * arr_off[j] - temp[j - 1] - (i + j - 1) / j);
            }
        }
        arr.push_back(temp);
    }
}

void solve()
{
    int n;
    cin >> n;
    int tt = n;
    int off = 0, ei = 0;
    for (auto x : fib) {
        while (tt % x == 0 && x != 1) {
            if (x == 144) off++;
            if (x == 8) ei++;
            tt = tt / x;
        }
    }
    int res = 0;
    if (tt == 1) {
        res = 1 * arr[ei][off];
    }
    cout << res << '\n';
}

signed main()
{
    fill_fib();
    fill_off();
    fill_ei();
    fill();
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
    return 0;
}